ALTER TABLE interact_ChatUsers CHANGE user user varchar(64) not null;
ALTER TABLE interact_Categories ADD StatusKey tinyint(2) NOT NULL AFTER CategoryParent;
ALTER TABLE interact_Categories ADD SortOrder int(3) NOT NULL AFTER StatusKey;
ALTER TABLE interact_Spaces ADD SortOrder int(3) NOT NULL AFTER LongDateFormatKey;
ALTER TABLE interact_Calendars ADD Type varchar(6) NOT NULL AFTER ParentCalendarKey;
ALTER TABLE interact_ForumSettings ADD FilePath varchar(20) NOT NULL default '' AFTER MinimumRepliesDefault;
ALTER TABLE interact_Forum ADD Attachment varchar(40) NOT NULL default '' AFTER ShowPhoto;
Alter table interact_Users ADD AutoLoadEditor tinyint(1) NOT NULL default '1' AFTER LanguageKey;
alter table interact_Modules change Description Description text not null;
ALTER TABLE interact_DropboxSettings ADD TypeKey tinyint(1) NOT NULL default '1' AFTER FilePath;
ALTER TABLE interact_DropboxSettings ADD TimeAllowed int(4) NOT NULL default '0' AFTER TypeKey;
ALTER TABLE interact_DropboxSettings ADD DownloadFile varchar(40) NOT NULL default '' AFTER TimeAllowed;
INSERT INTO interact_AccessLevels values ('5','Permanent Guest');
INSERT INTO interact_SpaceStatus VALUES (5,'Public');
CREATE TABLE interact_DropboxDownloadLinks (
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',  
  TimeDownloaded datetime NOT NULL default '0000-00-00 00:00:00',
  TimeUploaded datetime NOT NULL default '0000-00-00 00:00:00',
  FileName varchar(45) NOT NULL default '', 
  UNIQUE  (ModuleKey, UserKey)
) TYPE=MyISAM;
  

CREATE TABLE interact_CategoryExternalLinks (
  LinkKey int(11) NOT NULL auto_increment,
  CategoryKey int(11) NOT NULL default '0',
  Name varchar(255) NOT NULL default '',
  Url varchar(200) NOT NULL default '',
  SortOrder int(3) NOT NULL default '0',
  PRIMARY KEY  (LinkKey),    
  KEY CategoryKeyIdx (CategoryKey)
) TYPE=MyISAM;

INSERT INTO interact_ModuleTypes VALUES (17,'Quiz','quiz','','','quiz');

CREATE TABLE interact_QuizSettings (
  ModuleKey int(11) NOT NULL auto_increment,
  TypeKey tinyint(2) NOT NULL default '0',
  OpenDate datetime NOT NULL default '0000-00-00 00:00:00',
  CloseDate datetime NOT NULL default '0000-00-00 00:00:00',
  Attempts tinyint(2) NOT NULL default '0',
  ShuffleQuestions tinyint(1) NOT NULL default '0',
  ShuffleAnswers tinyint(1) NOT NULL default '0', 
  GradingKey tinyint(2) NOT NULL default '0',
  BuildOnPrevious tinyint(1) NOT NULL default '0',
  ShowFeedback tinyint(1) NOT NULL default '0', 
  ShowCorrect tinyint(1) NOT NULL default '0',
  MinutesAllowed int(3) NOT NULL default '0',            
  KEY ModuleKeyIdx (ModuleKey)
) TYPE=MyISAM;
CREATE TABLE interact_QTItem (
  ItemKey int(11) NOT NULL auto_increment,
  Name varchar(255) NOT NULL default '',
  Mattext text NOT NULL default '',
  ResponseType varchar(5) NOT NULL default '',
  RenderType varchar(20) NOT NULL default '',
  Rcardinality varchar(10) NOT NULL default '',
  Rtiming varchar(3) NOT NULL default '',
  AddedByKey int(11) NOT NULL default '0',
  ModifiedByKey int(11) NOT NULL default '0', 
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',   
  PRIMARY KEY  (ItemKey)
) TYPE=MyISAM;

CREATE TABLE interact_QTResponse (
  ItemKey int(11) NOT NULL default '0',
  Mattext text NOT NULL default '',
  Ident varchar(100) NOT NULL default '',
  UNIQUE  (Ident)
) TYPE=MyISAM;

CREATE TABLE interact_QTResprocessing (
  ItemKey int(11) NOT NULL default '0',
  ResponseIdent varchar(100) NOT NULL default '',
  Correct tinyint(1) NOT NULL default '0',
  Score tinyint(3) NOT NULL default '',
  FeedbackType varchar(100) NOT NULL default '',
  FeedbackLinkrefid varchar(100) NOT NULL default '',
  unique(ItemKey,ResponseIdent)  
) TYPE=MyISAM;

CREATE TABLE interact_QTFeedback (
  ItemKey int(11) NOT NULL default '0',
  FeedbackLinkrefid varchar(100) NOT NULL default '',
  Mattext text NOT NULL default ''
) TYPE=MyISAM;

CREATE TABLE interact_QTCategories (
  CategoryKey int(11) NOT NULL auto_increment,
  ParentKey int(11) NOT NULL default '0',
  Name varchar(255) NOT NULL default '',
  UserKey int(11) NOT NULL default '0',
  SpaceKey int(11) NOT NULL default '0',
  PRIMARY KEY  (CategoryKey)
) TYPE=MyISAM;

CREATE TABLE interact_QTCategoryItemLinks(
  CategoryKey int(11) NOT NULL default '0',
  ItemKey int(11) NOT NULL default '0',
  UNIQUE  (CategoryKey, ItemKey)
) TYPE=MyISAM;

CREATE TABLE interact_QTModuleItemLinks(
  LinkKey int(11) NOT NULL auto_increment,  
  ModuleKey int(11) NOT NULL default '0',
  ItemKey int(11) NOT NULL default '0',
  SortOrder int(4) NOT NULL default '0',
  Score int(4) NOT NULL default '0',
  PRIMARY KEY  (LinkKey)
) TYPE=MyISAM;

CREATE TABLE interact_QTAttempts(
  AttemptKey int(11) NOT NULL auto_increment,  
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  TimeStarted datetime NOT NULL default '0000-00-00 00:00:00', 
  TimeFinished datetime NOT NULL default '0000-00-00 00:00:00',   
  Score int(4) NOT NULL default '0',
  PRIMARY KEY  (AttemptKey)
) TYPE=MyISAM;

CREATE TABLE interact_QTAttemptsData(
  AttemptKey int(11) NOT NULL auto_increment,  
  ItemKey int(11) NOT NULL default '0',
  ResponseIdent varchar(100) NOT NULL default '',
  Correct tinyint(1) NOT NULL default '0',  
  Unique (AttemptKey, ItemKey)
) TYPE=MyISAM;

DROP TABLE IF EXISTS interact_Chat;
DROP TABLE IF EXISTS interact_ChatUsers;
DROP TABLE IF EXISTS interact_ChatBannlist;
DROP TABLE IF EXISTS interact_ChatRegisteredUsers;

CREATE TABLE interact_ChatMessages (
   type tinyint(1) DEFAULT '0' NOT NULL,
   room varchar(60) NOT NULL,
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   m_time int(11) DEFAULT '0' NOT NULL,
   address varchar(30) NOT NULL,
   message text NOT NULL
);

CREATE TABLE interact_ChatUsers (
   room varchar(60) NOT NULL,
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   u_time int(11) DEFAULT '0' NOT NULL,
   status varchar(1) NOT NULL,
   ip varchar(16) NOT NULL,
   UNIQUE room (room, username)
);


CREATE TABLE interact_ChatRegUsers (
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   password varchar(32) NOT NULL,
   firstname varchar(64) NOT NULL,
   lastname varchar(64) NOT NULL,
   country varchar(64) NOT NULL,
   website varchar(64) NOT NULL,
   email varchar(64) NOT NULL,
   showemail tinyint(1) NOT NULL,
   perms varchar(9) NOT NULL,
   rooms varchar(128) NOT NULL,
   reg_time int(11) DEFAULT '0' NOT NULL,
   ip varchar(16) NOT NULL,
   gender tinyint(1) DEFAULT '0' NOT NULL
);
INSERT INTO interact_ChatRegUsers VALUES('admin', '', '21232f297a57a5a743894a0e4a801fc3', '', '', '', '', '', 0, 'admin', '', '', '', '');

CREATE TABLE interact_ChatBanUsers (
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   ip varchar(16) NOT NULL,
   rooms varchar(100) NOT NULL,
   ban_until int(11) DEFAULT '0' NOT NULL
);